//*******************************//
// Soldering Station
// Matthias Wagner
// www.k-pank.de/so
// Get.A.Soldering.Station@gmail.com
//*******************************//

#include <Wire.h>
#include <Adafruit_GFX.h>    // Core graphics library
//#include <SWTFT.h>
#include <Adafruit_TFTLCD.h> // Hardware-specific library
#include "TouchScreen.h"
#include <SPI.h>

#define VERSION "1.5"

#define LCD_CS A3 //
#define LCD_CD A2 //
#define LCD_WR A1 //
#define LCD_RD A0 //
#define LCD_RESET A4 // 
#define YP A1  // must be an analog pin, use "An" notation!
#define XM A2  // must be an analog pin, use "An" notation!
#define YM 7   // can be a digital pin
#define XP 6   // can be a digital pin

#define MINPRESSURE 10
#define MAXPRESSURE 1000

//short TS_MINX = 155; // cordinates of panel
//short TS_MINY = 135; // 
//short TS_MAXX = 895; // 
//short TS_MAXY = 920; 
#define TS_MINX 920
#define TS_MINY 940
#define TS_MAXX 150
#define TS_MAXY 120

// Assegna alcuni colori utili
#define	BLACK   0x0000
#define	BLUE    0x001F
#define	RED     0xF800
#define	GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF

TouchScreen ts = TouchScreen(XP, YP, XM, YM, 300);
Adafruit_TFTLCD tft(LCD_CS, LCD_CD, LCD_WR, LCD_RD, LCD_RESET);
//SWTFT tft;

#define STANDBYin 12
//#define POTI    A7
#define TEMPin 	A5
#define PWMpin  11
//#define BLpin	11

#define CNTRL_GAIN 10

#define DELAY_MAIN_LOOP 	10
#define DELAY_MEASURE 		50
//#define ADC_TO_TEMP_GAIN 	0.415
#define ADC_TO_TEMP_GAIN 	0.53 //Mit original Weller Station verglichen
#define ADC_TO_TEMP_OFFSET 25.0
#define STANDBY_TEMP			175

#define OVER_SHOT 			2
#define MAX_PWM_LOW			180
#define MAX_PWM_HI			210		//254
//#define MAX_POTI			400		//400Grad C

#define PWM_DIV 1024			//default: 64   31250/64 = 2ms



//int conta = 0;
int pwm = 0; //pwm Out Val 0.. 255
int soll_temp = 300;
boolean standby_act = false;

void setup(void) {
	
         Serial.begin(9600);
  
	//pinMode(BLpin, OUTPUT);
	//digitalWrite(BLpin, LOW);
	
	 //digitalWrite(STANDBYin, HIGH);
	pinMode(STANDBYin, INPUT_PULLUP);
 
	pinMode(PWMpin, OUTPUT);
	digitalWrite(PWMpin, LOW);
	setPwmFrequency(PWMpin, PWM_DIV);
	digitalWrite(PWMpin, LOW);
	
        tft.reset();
        tft.begin(0x9325);
        tft.fillScreen(BLACK);
	SPI.setClockDivider(SPI_CLOCK_DIV4);  // 4MHz
	
        tft.drawRect(0, 0, 240, 318, CYAN);
        tft.drawLine(0, 260, 240, 260, WHITE);
        tft.drawLine(0, 220, 240, 220, WHITE);
        tft.drawLine(0, 119, 240, 119, WHITE);
        tft.drawLine(0, 20, 240, 20, CYAN);
        
	 // define button
        tft.fillRect(190, 120, 49, 49, RED);
        tft.fillRect(190, 170, 49, 49, BLUE);   
        tft.setCursor(208, 135);
        tft.setTextColor(WHITE);  tft.setTextSize(3);
        tft.println("+");
        tft.setCursor(208, 185);
        tft.setTextColor(WHITE);  tft.setTextSize(3);
        tft.println("-");
	
	tft.setTextSize(2);
	tft.setTextColor(GREEN);
	tft.setCursor(2,2);
	tft.print("RI-elektronika");
		
	tft.setTextSize(2);
	tft.setTextColor(YELLOW);
	tft.setCursor(180,2);
	tft.print("v ");
	tft.print(VERSION);
	
	tft.setTextColor(WHITE);

	tft.setTextSize(2);
	tft.setCursor(10,30);
	tft.print("TEMP");
	
	tft.setTextSize(2);
	tft.setCursor(125,52);
	tft.print("o");
	
  tft.setTextSize(4);
	tft.setCursor(140,65);
	tft.print("C");

	tft.setTextSize(2);
	tft.setCursor(10,129);
	tft.print("SET");
	
	tft.setTextSize(2);
	tft.setCursor(125,165);
	tft.print("o");
	
  tft.setTextSize(4);
	tft.setCursor(140,175);
	tft.print("C");

  tft.setTextSize(2);	
  tft.setCursor(80,235);
	tft.print("   %");
	
	tft.setTextSize(2);
	tft.setCursor(10,235);
	tft.print("pwm");

  tft.setTextColor(YELLOW);
  tft.setTextSize(2);
	tft.setCursor(20,280);
	tft.print("300");

  tft.setTextColor(MAGENTA);	
  tft.setCursor(105,280);
	tft.print("350");
	
	tft.setTextColor(GREEN);
	tft.setCursor(190,280);
	tft.print("400");

  tft.setTextColor(WHITE);
  tft.setCursor(30,170);
  tft.setTextSize(5);
  tft.print(soll_temp);

	tft.setTextSize(2);
	
}

void loop() {
	
	int actual_temperature = getTemperature();
	//soll_temp = map(analogRead(POTI), 0, 1024, 0, MAX_POTI);

	TSPoint p = ts.getPoint();
	pinMode(XM, OUTPUT);
  pinMode(YP, OUTPUT);
        
         if (p.z > MINPRESSURE && p.z < MAXPRESSURE)
  {
    p.x = tft.width() - (map(p.x, TS_MINX, TS_MAXX, tft.width(), 0));
    p.y = tft.height() - (map(p.y, TS_MINY, TS_MAXY, tft.height(), 0));
    if (p.y > 200)
    
    Serial.print("\tX = "); Serial.print(p.x);
    Serial.print("\tY = "); Serial.print(p.y);
    Serial.print("\tPressure = "); Serial.println(p.z);
    
          
           if ((p.x >5) && (p.y <260 )) {           
           tft.fillRect(28, 170, 95, 40, BLACK); 
           if ((p.y > 150) && (p.y < 210)) {           // up temp
           soll_temp = soll_temp + 5;
           } else if ((p.y >100) && (p.y < 150 )) {    // down temp
           soll_temp = soll_temp - 5;
           }
           
           if((p.x > 160 && p.x < 240) && (p.y > 0 && p.y < 90)) {         
           soll_temp = 300;
           } 
           if ((p.x >80 && p.x < 160 )&& (p.y > 0 && p.y < 90)) {    
           soll_temp = 350;
           }
           if ((p.x >0) && (p.x < 80 )&& (p.y > 0 && p.y < 90)) {    
           soll_temp = 400;
           }
      }
if (soll_temp > 480.00) 
soll_temp = 0 ;      
tft.setTextColor(WHITE);
tft.setCursor(30,170);
tft.setTextSize(5);
tft.print(soll_temp);
delay (10);
//if (soll_temp < 100)
//tft.print(" ");
//if (soll_temp <10)
//tft.print(" ");

}

//conta = conta +1;

//if (conta > 100){
    //conta = 0;
    
    //tft.fillRect(40, 45, 190, 50, BLACK);  // erase
    //tft.fillRect(40, 150, 190, 50, BLACK);  // erase

	//TODO: Put in Funktion
tft.setTextSize(2);
	tft.setCursor(200,65);
	if (digitalRead(STANDBYin) == true)
		tft.setTextColor(BLACK);
	else
		tft.setTextColor(WHITE);
	tft.print("SB");

      
	int soll_temp_tmp = soll_temp;
	if (digitalRead(STANDBYin) == false)
		standby_act = true;
	else
		standby_act = false;
	
	if (standby_act && (soll_temp >= STANDBY_TEMP ))
		soll_temp_tmp = STANDBY_TEMP;
	
	int diff = (soll_temp_tmp + OVER_SHOT)- actual_temperature;
	pwm = diff*CNTRL_GAIN;

	
	int MAX_PWM;

	//Set max heating Power 
	MAX_PWM = actual_temperature <= STANDBY_TEMP ? MAX_PWM_LOW : MAX_PWM_HI;
	
	//8 Bit Range
	pwm = pwm > MAX_PWM ? pwm = MAX_PWM : pwm < 0 ? pwm = 0 : pwm;
	
	
	
	//NOTfall sicherheit / Spitze nicht eingesteckt
	if (actual_temperature > 550){
		pwm = 0;
		actual_temperature = 0;
	}
	
	
	analogWrite(PWMpin, pwm);
	//digitalWrite(PWMpin, LOW);
	
	writeHEATING(soll_temp, actual_temperature, pwm);
	
	delay(DELAY_MAIN_LOOP);		//wait for some time
//}
}

int getTemperature()
{
  analogWrite(PWMpin, 0);		//switch off heater
  delay(DELAY_MEASURE);			//wait for some time (to get low pass filter in steady state)
  int adcValue = analogRead(TEMPin); // read the input on analog pin 7:
  Serial.print("ADC Value ");
  Serial.print(adcValue);
  analogWrite(PWMpin, pwm);	//switch heater back to last value
  return round(((float) adcValue)*ADC_TO_TEMP_GAIN+ADC_TO_TEMP_OFFSET); //apply linear conversion to actual temperature
}

void writeHEATING(int tempSOLL, int tempVAL, int pwmVAL){
	//static int d_tempSOLL = 2;		//Tiefpass für Anzeige (Poti zittern)

	//static int tempSOLL_OLD = 	10;
	static int tempVAL_OLD	= 	10;
	static int pwmVAL_OLD	= 	10;
	//TFT Anzeige
	
	pwmVAL = map(pwmVAL, 0, 254, 0, 100);
	
	tft.setTextSize(5);
	if (tempVAL_OLD != tempVAL){
		tft.setCursor(30,57);
		tft.setTextColor(BLACK);
		//tft.print(tempSOLL_OLD);
		//erste Stelle unterschiedlich
		if ((tempVAL_OLD/100) != (tempVAL/100)){
			tft.print(tempVAL_OLD/100);
		}
		else
			tft.print(" ");
		
		if ( ((tempVAL_OLD/10)%10) != ((tempVAL/10)%10) )
			tft.print((tempVAL_OLD/10)%10 );
		else
			tft.print(" ");
		
		if ( (tempVAL_OLD%10) != (tempVAL%10) )
			tft.print(tempVAL_OLD%10 );
		
		tft.setCursor(30,57);
		tft.setTextColor(WHITE);
		
		if (tempVAL < 100)
			tft.print(" ");
		if (tempVAL <10)
			tft.print(" ");
		
		int tempDIV = round(float(tempSOLL - tempVAL)*8.5);
		tempDIV = tempDIV > 254 ? tempDIV = 254 : tempDIV < 0 ? tempDIV = 0 : tempDIV;
		tft.setTextColor(Color565(tempDIV, 255-tempDIV, 0));
		if (standby_act)
		tft.setTextColor(CYAN);
		tft.print(tempVAL);
		
		tempVAL_OLD = tempVAL;
	}
	
	        //if (tempSOLL_OLD != tempSOLL){
	//if ((tempSOLL_OLD+d_tempSOLL < tempSOLL) || (tempSOLL_OLD-d_tempSOLL > tempSOLL)){
		//tft.setCursor(30,102);
		//tft.setTextColor(BLACK);
		      //tft.print(tempSOLL_OLD);
		      //erste Stelle unterschiedlich
		//if ((tempSOLL_OLD/100) != (tempSOLL/100)){
			//tft.print(tempSOLL_OLD/100);
		//}
		//else
			//tft.print(" ");
		
		//if ( ((tempSOLL_OLD/10)%10) != ((tempSOLL/10)%10) )
			//tft.print((tempSOLL_OLD/10)%10 );
		//else
			//tft.print(" ");
		
		//if ( (tempSOLL_OLD%10) != (tempSOLL%10) )
			//tft.print(tempSOLL_OLD%10 );
		
		//Neuen Wert in Weiß schreiben
		//tft.setCursor(30,102);
		//tft.setTextColor(WHITE);
		//if (tempSOLL < 100)
			//tft.print(" ");
		//if (tempSOLL <10)
			//tft.print(" ");
		
		//tft.print(tempSOLL);
		//tempSOLL_OLD = tempSOLL;
		
	//}
	
	
	tft.setTextSize(2);
	if (pwmVAL_OLD != pwmVAL){
		tft.setCursor(80,235);
		tft.setTextColor(BLACK);
		//tft.print(tempSOLL_OLD);
		//erste stelle Unterscheidlich
		if ((pwmVAL_OLD/100) != (pwmVAL/100)){
			tft.print(pwmVAL_OLD/100);
		}
		else
			tft.print(" ");
		
		if ( ((pwmVAL_OLD/10)%10) != ((pwmVAL/10)%10) )
			tft.print((pwmVAL_OLD/10)%10 );
		else
			tft.print(" ");
		
		if ( (pwmVAL_OLD%10) != (pwmVAL%10) )
			tft.print(pwmVAL_OLD%10 );
		
		tft.setCursor(80,235);
		tft.setTextColor(WHITE);
		if (pwmVAL < 100)
			tft.print(" ");
		if (pwmVAL <10)
			tft.print(" ");
		
		tft.print(pwmVAL);
		pwmVAL_OLD = pwmVAL;
		
	}
	
}

// Pass 8-bit (each) R,G,B, get back 16-bit packed color
  uint16_t Color565(uint8_t r, uint8_t g, uint8_t b) {
  return ((r & 0xF8) << 8) | ((g & 0xFC) << 3) | (b >> 3);
}


void setPwmFrequency(int pin, int divisor) {
  byte mode;
  if(pin == 5 || pin == 6 || pin == 9 || pin == 10) {
    switch(divisor) {
      case 1: mode = 0x01; break;
      case 8: mode = 0x02; break;
      case 64: mode = 0x03; break;
      case 256: mode = 0x04; break;
      case 1024: mode = 0x05; break;
      default: return;
    }
    if(pin == 5 || pin == 6) {
      TCCR0B = TCCR0B & 0b11111000 | mode;
    } else {
      TCCR1B = TCCR1B & 0b11111000 | mode;
    }
  } else if(pin == 3 || pin == 11) {
    switch(divisor) {
      case 1: mode = 0x01; break;
      case 8: mode = 0x02; break;
      case 32: mode = 0x03; break;
      case 64: mode = 0x04; break;
      case 128: mode = 0x05; break;
      case 256: mode = 0x06; break;
      case 1024: mode = 0x7; break;
      default: return;
    }
    TCCR2B = TCCR2B & 0b11111000 | mode;
  }
}
